<?php
/**
 *    etope 8 OXID Shopconnection.
 *
 *    Dieses Script ist Eigentum der Freshworx GmbH und Co.KG 
 *    Weitere Informationen finden Sie unter <http://freshworx.com>.
 *
 * @link http://freshworx.com
 * @package et8wservuceMVR1
 * @copyright (C) Freshworx GmbH & Co. KG 2011-2012
 * @version OXID MVR1
 *
 * Hinweis: Sofern Sie ?er einen separaten HTTPS Bereich verf?en legen Sie dieses Script dort hin
 * und geben Sie in etope die entsprechenden HTTPS Daten an.
 */
 
/**
 *	Token. Der Token sichert dieses Script ab. Deaktivieren Sie auf keinen Fall diese Funktion.
 *  Geben Sie hier den von Freshworx erhaltenen Sicherheitsschl?sel (Token) an. Achten Sie darauf das der Token
 *  innerhalb der ' Zeichen steht.
 */
 
if ( defined( 'E_DEPRECATED' ) ) {
    //E_DEPRECATED is disabled particularly for PHP 5.3 as some 3rd party modules still uses deprecated functionality
    error_reporting( E_ALL ^ E_NOTICE ^ E_DEPRECATED );
} else {
    error_reporting( E_ALL ^ E_NOTICE );
}

echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
 
define('ET8TOK','HIER DER TOKEN');
 

/**
 *	Tokenpruefung
 */
 if (empty($_POST['token'])) $_POST['token']="clear";
 if ($_POST['token']!=ET8TOK) { 
 	echo "<oxidresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Token is invalid</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<oxidresponse>";
 	exit;
 }

 /**
 *	Ersatzfunktion zur Einlesung von externen Bildern
 */ 
function get_content($url)
{
    $ch = curl_init();
    curl_setopt ($ch, CURLOPT_URL, $url);
    curl_setopt ($ch, CURLOPT_HEADER, 0);
    ob_start();
    curl_exec ($ch);
    curl_close ($ch);
    $string = ob_get_contents();
    ob_end_clean();
    return $string;     
}
 
 /**
 *	Ersatzfunktion Pfad Shop
 */  
function getShopBasePath()
{
    return dirname(__FILE__).'/';
}

 /**
 *	Decoder
 */  
function strRot13( $sStr )
{
	$sFrom = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
	$sTo   = 'nopqrstuvwxyzabcdefghijklmNOPQRSTUVWXYZABCDEFGHIJKLM';

	return strtr( $sStr, $sFrom, $sTo );
}

 /**
 *	Bank Parser
 */  
function makeBankArray( $sIn)
{
	$bankdata = array();
	$returnData = array();
	
	$bankdata = explode("@@",$sIn);
	unset($bankdata[4]);

	foreach($bankdata as $key => $val)
	{
		$tmpData = explode("__", $val);
		if(!empty($tmpData))
		{
			$returnData[$tmpData[0]] = $tmpData[1];
		}
	}
	
	return $returnData;
}


/**
 *	Shop init
 */  
require getShopBasePath().'modules/functions.php';
require_once getShopBasePath().'core/oxfunctions.php';
require_once getShopBasePath().'core/oxutils.php';

if (class_exists('oxConfigFile')){
	$config = new oxConfigFile( getShopBasePath()."config.inc.php" ); 
	oxRegistry::set("oxConfigFile", $config );
	oxRegistry::get("oxUtils");
} else { 
	class config { 
  		function config() { 
  		 include('config.inc.php'); 
  		}	 
	}
	$config = new config(); 
}

$sTmpFolder = $config->sCompileDir;
$sShopDir = $config->sShopDir;
 
 /**
 *	Datenbank verbinden
 */  
if (!$db = @MYSQL_CONNECT($config->dbHost,$config->dbUser,$config->dbPwd)) { 
 	echo "<oxidresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Connection failed! ".mysql_error()."</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<oxidresponse>";
	exit;
}
$db_check = @MYSQL_SELECT_DB($config->dbName);		


 
 
/**
 *	Ist der Token in Ordnung etope8 Befehle decodieren und ausf?ren.
 */
 if ($_POST['say']=="") { 
 	echo "<oxidresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Request is invalid</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<oxidresponse>";
 	exit;
 }

 $say=$_POST['say'];
 $say=str_replace("[-P]","+",$say);
 $say=str_replace("[-G]","=",$say);
 $say=base64_decode($say);
 
 // Kleinere Korrekturen
 $say=str_ireplace("OXINSERT='0000-00-00'","OXINSERT=NOW()",$say);
 $say=str_ireplace("OXINSERT='0000-00-00 00:00:00'","OXINSERT=NOW()",$say);

 if ($config->iUtfMode == 1 AND (strpos($say,"oxcategories") OR strpos($say,"oxobject2seodata") OR strpos($say,"oxarticles") OR strpos($say,"oxartextends") OR strpos($say,"oxorder"))) {
	mysql_query( 'SET NAMES "utf8"' );
	mysql_query( 'SET CHARACTER SET utf8' );
	mysql_query( 'SET CHARACTER_SET_CONNECTION = utf8' );
	mysql_query( 'SET CHARACTER_SET_DATABASE = utf8' );
	// mysql_query( 'SET character_set_results = utf8' );
	mysql_query( 'SET character_set_server = utf8' );
	$say=UTF8_ENCODE($say); 
 }



 

/**
 *	Diese Funktion holt externe Bilder und ladet diese in das Master Verzeichnis, im SQL wird dann die entsprechende Passage ersetzt.
 */
   for($count = 1; $count < 10; $count++){
	if (strpos($say,"OXPIC".$count."='")){
		$bild=substr($say,strpos($say,"OXPIC".$count."='")+8,strlen($say));
		$bild=substr($bild,0,strpos($bild,"'"));
		if ($bild=="") Continue;
		if (strpos($bild,"ttp:/")===false AND strpos($bild,"ttps:/")==false) Continue;
		$extfilesp=split("/",$bild); 
		$extfilename=$extfilesp[count($extfilesp)-1];
		$extbdata=get_content($bild);
		if (!$handle=fopen($sShopDir."/out/pictures/master/product/".$count."/".strtolower($extfilename),"w")){
		 	echo "<oxidresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Bild konnte nicht nach ".$sShopDir."/out/pictures/master/product/".$count."/ geladen werden.\n\n".mysql_error()."</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<oxidresponse>";
			exit;
		} else {
			fwrite($handle,$extbdata);
			fclose($handle);
			$say=str_replace("OXPIC".$count."='".$bild."'","OXPIC".$count."='".strtolower($extfilename)."'",$say);
			// if (strpos($say,"OXPICSGENERATED")===false) $say=str_replace("OXPIC".$count."='","OXPICSGENERATED=0,OXPIC".$count."='",$say);
		}
	}
   }
   
/**
 *	Bei Kategorien gibt es einige Funktionen mehr
 */
   if (strpos($say,"oxcategories")){
	if (strpos($say,"OXICON='")){
		$bild=substr($say,strpos($say,"OXICON='")+8,strlen($say));
		$bild=substr($bild,0,strpos($bild,"'"));
		if ($bild!=""){
			if (strpos($bild,"ttp:/")===false AND strpos($bild,"ttps:/")===false) Continue;
			$extfilesp=split("/",$bild); 
			$extfilename=$extfilesp[count($extfilesp)-1];
			$extbdata=get_content($bild);
			if (!$handle=fopen($sShopDir."/out/pictures/master/category/icon/".strtolower($extfilename),"w")){
		 		echo "<oxidresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Bild konnte nicht nach ".$sShopDir."/out/pictures/master/category/icon/"." geladen werden.\n\n".mysql_error()."</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<oxidresponse>";
				exit;
			} else {
				fwrite($handle,$extbdata);
				fclose($handle);
				$say=str_replace("OXICON='".$bild."'","OXICON='".strtolower($extfilename)."'",$say);
			}
		}
	}
	if (strpos($say,"OXPROMOICON='")){
		$bild=substr($say,strpos($say,"OXPROMOICON='")+13,strlen($say));
		$bild=substr($bild,0,strpos($bild,"'"));
		if ($bild!=""){
			if (strpos($bild,"ttp:/")===false AND strpos($bild,"ttps:/")===false) Continue;
			$extfilesp=split("/",$bild); 
			$extfilename=$extfilesp[count($extfilesp)-1];
			$extbdata=get_content($bild);
			if (!$handle=fopen($sShopDir."/out/pictures/master/category/promo_icon/".strtolower($extfilename),"w")){
		 		echo "<oxidresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Bild konnte nicht nach ".$sShopDir."/out/pictures/master/category/promo_icon/"." geladen werden.\n\n".mysql_error()."</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<oxidresponse>";
				exit;
			} else {
				fwrite($handle,$extbdata);
				fclose($handle);
				$say=str_replace("OXPROMOICON='".$bild."'","OXPROMOICON='".strtolower($extfilename)."'",$say);
			}
		}
	}
	if (strpos($say,"OXTHUMB='")){
		$bild=substr($say,strpos($say,"OXTHUMB='")+9,strlen($say));
		$bild=substr($bild,0,strpos($bild,"'"));
		if ($bild!=""){
			if (strpos($bild,"ttp:/")===false AND strpos($bild,"ttps:/")===false) Continue;
			$extfilesp=split("/",$bild); 
			$extfilename=$extfilesp[count($extfilesp)-1];
			$extbdata=get_content($bild);
			if (!$handle=fopen($sShopDir."/out/pictures/master/category/thumb/".strtolower($extfilename),"w")){
		 		echo "<oxidresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Bild konnte nicht nach ".$sShopDir."/out/pictures/master/category/thumb/"." geladen werden.\n\n".mysql_error()."</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<oxidresponse>";
				exit;
			} else {
				fwrite($handle,$extbdata);
				fclose($handle);
				$say=str_replace("OXTHUMB='".$bild."'","OXTHUMB='".strtolower($extfilename)."'",$say);
			}
		}
	}
	for($iii=0; $iii<5; $iii++){
		if (strpos($say,"OXTHUMB_".$iii."='")){
			$bild=substr($say,strpos($say,"OXTHUMB_".$iii."='")+11,strlen($say));
			$bild=substr($bild,0,strpos($bild,"'"));
			if ($bild!=""){
				if (strpos($bild,"ttp:/")===false AND strpos($bild,"ttps:/")===false) Continue;
				$extfilesp=split("/",$bild); 
				$extfilename=$extfilesp[count($extfilesp)-1];
				$extbdata=get_content($bild);
				if (!$handle=fopen($sShopDir."/out/pictures/master/category/thumb/".strtolower($extfilename),"w")){
			 		echo "<oxidresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Bild konnte nicht nach ".$sShopDir."/out/pictures/master/category/thumb/"." geladen werden.\n\n".mysql_error()."</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<oxidresponse>";
					exit;
				} else {
					fwrite($handle,$extbdata);
					fclose($handle);
					$say=str_replace("OXTHUMB_".$iii."='".$bild."'","OXTHUMB_".$iii."='".strtolower($extfilename)."'",$say);
				}
			}
		}
	}
   }
	 
 
   // Hersteller Bilder
   if (strpos($say,"oxmanufacturers")){
	if (strpos($say,"OXICON='")){
		$bild=substr($say,strpos($say,"OXICON='")+8,strlen($say));
		$bild=substr($bild,0,strpos($bild,"'"));
		if ($bild!=""){
			if (strpos($bild,"ttp:/")===false AND strpos($bild,"ttps:/")===false) Continue;
			$extfilesp=split("/",$bild); 
			$extfilename=$extfilesp[count($extfilesp)-1];
			$extbdata=get_content($bild);
			if (!$handle=fopen($sShopDir."/out/pictures/master/manufacturer/icon/".strtolower($extfilename),"w")){
		 		echo "<oxidresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Bild konnte nicht nach ".$sShopDir."/out/pictures/master/manufacturer/icon/"." geladen werden.\n\n".mysql_error()."</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<oxidresponse>";
				exit;
			} else {
				fwrite($handle,$extbdata);
				fclose($handle);
				$say=str_replace("OXICON='".$bild."'","OXICON='".strtolower($extfilename)."'",$say);
			}
		}
	} 
  }

/**
 *	Da OXID mit einigen IDs arbeitet ben?igen wir einige Grundinformationen.
 */ 

 $payment=array();
 $result=mysql_query("SELECT OXID,OXDESC FROM oxpayments");
 while ($row=mysql_fetch_array($result)){
   $payment[$row['OXID']]=$row['OXDESC'];    
 }

 $delivery=array();
 $result=mysql_query("SELECT OXID,OXTITLE FROM oxdeliveryset");
 while ($row=mysql_fetch_array($result)){
   if ($row['OXTITLE']=="" AND $row['OXTITLE_1']!="") $row['OXTITLE']=$row['OXTITLE_1'];
   $delivery[$row['OXID']]=$row['OXTITLE'];
 }
 if ($delivery['oxidstandard']=="") $delivery['oxidstandard']="Standard";


 $result=mysql_query($say);
 if (mysql_error()!="") { 
 	echo "<oxidresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Request is invalid.\n\n".mysql_error()."</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<oxidresponse>";
 	exit;
 }
 if (strpos($say,"NSERT INTO") OR strpos($say,"PDATE ")){
 	// oxUtils::getInstance()->oxResetFileCache();
 }


 
 $myecho="";
 $myecho.= "<oxidresponse>\n";
 $myecho.= "\t<Ack>Success</Ack>\n";
 $myecho.= "\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n";
 $myecho.= "\t<TotalNumberOfItems>".mysql_num_rows($result)."</TotalNumberOfItems>\n";
 $myecho.= "\t<XUPDATEIDFIELD></XUPDATEIDFIELD>\n";
 $myecho.= "\t<XUPDATETABLE></XUPDATETABLE>\n";
 $myecho.= "\t<showfield></showfield>\n";
 $myecho.= "\t<thisansub></thisansub>\n";
 $myecho.= "\t<dataitems>\n";

 while ($row=mysql_fetch_assoc($result)){

   $myecho.= "\t<dataitem>\n";
    
   // Keine UserID?
   if (isset($row['OXBILLEMAIL'])){
	   $cu = mysql_query("SELECT * FROM oxuser WHERE OXID='".$row['OXUSERID']."'");
	   $cuu = mysql_fetch_assoc($cu);
	   foreach($cuu AS $cuukey => $cuuval){
			$myecho.=  "\t\t<customer_".$cuukey."><![CDATA[".$cuuval."]]></customer_".$cuukey.">\n";
	   }
   	   if ($row['OXBILLEMAIL']=="") $row["OXBILLEMAIL"]=$cuu["OXUSERNAME"];
   }
   
   // Spezielle Modifikation fuer OXID
   if ($row['OXBILLLNAME']!="" OR $row['OXBILLSTREET']!="" OR $row['OXBILLCITY']!=""){
	   if ($row['OXDELLNAME']=="" AND $row['OXDELSTREET']=="" AND $row['OXDELCITY']==""){
			$row['OXDELCOMPANY']=$row['OXBILLCOMPANY'];
			$row['OXDELFNAME']=$row['OXBILLFNAME'];
			$row['OXDELLNAME']=$row['OXBILLLNAME'];
			$row['OXDELSTREET']=$row['OXBILLSTREET'];
			$row['OXDELSTREETNR']=$row['OXBILLSTREETNR'];
			$row['OXDELADDINFO']=$row['OXBILLADDINFO'];
			$row['OXDELCITY']=$row['OXBILLCITY'];
			$row['OXDELCOUNTRYID']=$row['OXBILLCOUNTRYID'];
			$row['OXDELSTATEID']=$row['OXBILLSTATEID'];
			$row['OXDELZIP']=$row['OXBILLZIP'];
			$row['OXDELFON']=$row['OXBILLFON'];
			$row['OXDELFAX']=$row['OXBILLFAX'];
			$row['OXDELSAL']=$row['OXBILLSAL'];
	   }   	 
   }

   // Gutscheine?
   if ($row['OXVOUCHERDISCOUNT']>0) {
   	$row['OXDISCOUNT']+=$row['OXVOUCHERDISCOUNT'];
   	$OXV=mysql_query("SELECT * FROM oxvouchers WHERE OXORDERID='".$row['OXORDERID']."'");
   	while ($OXVROW=mysql_fetch_array($OXV)){
   		$row['OXDISCOUNTINFO'].=$OXVROW['OXVOUCHERNR']." - ".$OXVROW['OXRESERVED'];
   	}
   }
   
   foreach($row as $key => $value){
     if (($key=="OXBILLCOUNTRYID" OR $key=="OXDELCOUNTRYID") AND $value!=""){ 
     	$cou=mysql_query("SELECT OXISOALPHA2,OXTITLE FROM oxcountry WHERE OXID='".$value."'");
     	if ($courow=mysql_fetch_array($cou)) {
     		$value=$courow['OXTITLE'];
     		$myecho.= "\t\t".'<'.$key.'_CODE><![CDATA['.trim($courow['OXISOALPHA2']).']]></'.$key.'_CODE>'."\n";
     	}
     }
     if ($key=="OXPAYMENTTYPE" AND !empty($payment[$value])) $value=$payment[$value];
     if ($key=="OXDELTYPE" AND !empty($delivery[$value])) $value=$delivery[$value];
     if ($key=="OXBILLSTREET") $value.=" ".$row['OXBILLSTREETNR'];
     if ($key=="OXDELSTREET")  $value.=" ".$row['OXDELSTREETNR'];
     if ($key=="OXTITLE" AND $row['OXSELVARIANT']!="") $value.=" ".$row['OXSELVARIANT'];
     $myecho.= "\t\t".'<'.$key.'><![CDATA['.trim($value).']]></'.$key.'>'."\n";
   }
   
   
   if (isset($row['OXPAYMENTID'])){
   	  // Bankverbindung holen?
   	  $paymentKey = 'fq45QS09_fqyx09239QQ';
	  $paymentKey = strRot13($paymentKey);
      $oxuserpayments=mysql_query("SELECT DECODE(OXVALUE, '".$paymentKey."') AS OXVALUE ,OXPAYMENTSID FROM oxuserpayments WHERE OXID='".$row['OXPAYMENTID']."'");
      if (mysql_num_rows($oxuserpayments)>0){
      	 $oxuserpaymentsrow = mysql_fetch_array($oxuserpayments);
 
      	 $op=makeBankArray($oxuserpaymentsrow['OXVALUE']);
      	 foreach($op AS $opkey => $opval){
      	 	if (trim($opkey)!="") $myecho.="\t\t<".$opkey."><![CDATA[".$opval."]]></".$opkey.">\n";
      	 }
      	  
      }
   }
  
  
   
   $myecho.= "\t\t<thislineend>1</thislineend>\n";
   $myecho.= "\t</dataitem>\n";
 } 
 $myecho.= "\t<dataitems>\n";
 $myecho.= "</oxidresponse>\n";
 if ($config->iUtfMode != 1) echo UTF8_ENCODE($myecho); else echo $myecho;
 
 
 


?>