<?php
/**
 *    etope 8 Shopware Shopconnection.
 *
 *    Dieses Script ist Eigentum der Freshworx GmbH und Co.KG 
 *    Weitere Informationen finden Sie unter <http://freshworx.com>.
 *
 * @link http://freshworx.com
 * @package et8wserviceMVR1
 * @copyright (C) Freshworx GmbH & Co. KG 2011-2012
 * @version Shopware MVR1
 *
 * Hinweis: Sofern Sie ueer einen separaten HTTPS Bereich verf?en legen Sie dieses Script dort hin
 * und geben Sie in etope die entsprechenden HTTPS Daten an.
 */
 
 /*
 * 2012-12-06: Beginn Aufbau.
 * 2014-03-09: Kompatiblität Shopware 4.1
 */
 
/**
 *	Token. Der Token sichert dieses Script ab. Deaktivieren Sie auf keinen Fall diese Funktion.
 *  Geben Sie hier den von Freshworx erhaltenen Sicherheitsschl?sel (Token) an. Achten Sie darauf das der Token
 *  innerhalb der ' Zeichen steht.
 */
 define(ET8TOK,'HIER DER TOKEN');
 
    
 /**
 *	Tokenpruefung
 */
 if (empty($_POST['token'])) $_POST['token']="clear";
 if ($_POST['token']!=ET8TOK) { 
 	echo "<shopwareresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Token is invalid</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<shopwareresponse>";
 	exit;
 }
 
 
/**
 *	Datenbank verbinden...
 */ 
	$config = include("config.php");
	 
    $db=@MYSQL_CONNECT($config['db']['host'],$config['db']['username'],$config['db']['password']) or die ("<shopwareresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Databaseconnection error!</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<shopwareresponse>");
    $db_check=@MYSQL_SELECT_DB($config['db']['dbname']);
	
	echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
	

/**
 *	Folgende Funktionen werden vom etope Webservice genutzt. Eine ?derung darf hier nicht erfolgen.
 */

/**
 *	Ist der Token in Ordnung etope8 Befehle decodieren
 */
if ($_POST['say']=="") {
 	echo "<shopwareresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Request is invalid</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<shopwareresponse>";
 	exit;
}
$say=$_POST['say'];
$say=str_replace("[-P]","+",$say);
$say=str_replace("[-G]","=",$say);
$say=base64_decode($say);




$result=mysql_query($say);
if (mysql_error()!="") {
 	echo "<shopwareresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Request is invalid.\n\n".mysql_error()."</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<shopwareresponse>";
 	exit;
}

$myecho = "";
$myecho.= "<shopwareresponse>\n";
$myecho.= "\t<Ack>Success</Ack>\n";
$myecho.= "\t<ServerTime>".date("Y-m-d H:m:s")."</ServerTime>\n";


while ($row=mysql_fetch_assoc($result)){
    
    if (isset($row['ordertime'])){
        
        // Payment Code
        if ((int)$row['paymentID']>0){
            $paytrans=mysql_query("SELECT * FROM s_core_paymentmeans WHERE id='".$row['paymentID']."'");
            if (mysql_num_rows($paytrans)>0){
                $paytransrow=mysql_fetch_array($paytrans);
                $row['paymentID']=$paytransrow['description'];
            }
        }
        
        
        $row['OrderLineItemID']="shw-".$row['orderID']."-".$row['articleID'].$row['ordertime'];
        
        // Kunde holen...
        $k=mysql_query("SELECT sb.*,sc.countryname,sc.countryiso FROM s_order_billingaddress sb, s_core_countries sc WHERE sb.countryID=sc.id AND sb.orderID='".$row['orderID']."'");
        if (mysql_num_rows($k)>0){
            $kk=mysql_fetch_assoc($k);
            foreach($kk AS $kkkey => $kkval) $row['billing_'.$kkkey]=$kkval;
            $row['billing_street_complete']=trim($row['billing_street']." ".$row['billing_streetnumber']);
        }
        
        $k=mysql_query("SELECT sb.*,sc.countryname,sc.countryiso FROM s_order_shippingaddress sb, s_core_countries sc WHERE sb.countryID=sc.id AND sb.orderID='".$row['orderID']."'");
        if (mysql_num_rows($k)>0){
            $kk=mysql_fetch_assoc($k);
            foreach($kk AS $kkkey => $kkval) $row['shipping_'.$kkkey]=$kkval;
            $row['shipping_street_complete']=trim($row['shipping_street']." ".$row['shipping_streetnumber']);
        }
        
        $k=mysql_query("SELECT * FROM s_user WHERE id='".$row['userID']."'");
        if (mysql_num_rows($k)>0){
            $kk=mysql_fetch_assoc($k);
            foreach($kk AS $kkkey => $kkval) $row['s_user_'.$kkkey]=$kkval;
        }
        
        if ($row['taxID']!="0" AND $row['taxID']!=""){
       		$tax = mysql_query("SELECT `tax` FROM s_core_tax WHERE `id`='".$row['taxID']."'");
       		if (!mysql_error()){
       			if (mysql_num_rows($tax)>0){
       				$tax=mysql_fetch_array($tax);
       				$row['tax_rate'] = $tax['tax'];
       			}
       		}
       }
        
    } // ende if date pruch
    
    $myecho.= "\t<dataitem>\n";
    
    foreach($row as $key => $value){
        $myecho.= "\t\t".'<'.$key.'><![CDATA['.$value.']]></'.$key.'>'."\n";
    }
    $myecho.= "\t\t<thislineend>1</thislineend>\n";
    $myecho.= "\t</dataitem>\n";
} 
$myecho.= "</shopwareresponse>\n";


echo UTF8_ENCODE($myecho);

 
 
?>