<?php
/**
 *    etope 8 XT Shopconnection.
 *
 *    Dieses Script ist Eigentum der Freshworx GmbH und Co.KG 
 *    Weitere Informationen finden Sie unter <http://freshworx.com>.
 *
 * @link http://freshworx.com
 * @package et8wserviceMVR1
 * @copyright (C) Freshworx GmbH & Co. KG 2011-2015
 * @version XT MVR1
 *
 * Hinweis: Sofern Sie ?er einen separaten HTTPS Bereich verf?en legen Sie dieses Script dort hin
 * und geben Sie in etope die entsprechenden HTTPS Daten an.
 */
 
 /*
 * 2012-01-21: Die Funktion make_thumb wurde integriert (XT4).
 * 2012-10-30: Veyton Versandkosten werden nun Brutto ausgegeben.
 * 2013-07-01: Veyton Zahlungsmethode wird ausgegeben in payment_class
 * 2013-07-05: Integration Veyton Versand setzen
 * 2013-07-15: OS Commerce Korrektur zu Adressinformationen
 * 2013-10-31: Attributgebuehren bei XT<4 nicht mehr aufaddieren
 */
 
/**
 *	Token. Der Token sichert dieses Script ab. Deaktivieren Sie auf keinen Fall diese Funktion.
 *  Geben Sie hier den von Freshworx erhaltenen Sicherheitsschl?sel (Token) an. Achten Sie darauf das der Token
 *  innerhalb der ' Zeichen steht.
 */
 define(ET8TOK,'TOKEN HIER REIN');
 define('_VALID_CALL','true');
 define('THUMB_SIZE',120);
 define('INFO_SIZE',200);
 define('ICON_SIZE',80);
 $xtversion=""; // XT Version, 3 oder 4
 

/**
 *	Der nachfolgende Codeteil stammt aus der XT Indexdatei und kann bei Versionsabweichungen angepasst werden.
 */
       $pref="";
	   $orgpost=$_POST;
       if (file_exists('includes/application_top.php')){
	   	  include ('includes/application_top.php');
	   	  $xtversion=3;
       } else {
          require ('conf/config.php');
          require ('conf/paths.php');
          $db=@MYSQL_CONNECT(_SYSTEM_DATABASE_HOST,_SYSTEM_DATABASE_USER,_SYSTEM_DATABASE_PWD) or die ("<xtresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Databaseconnection error!</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<xtresponse>"); 
          $db_check=@MYSQL_SELECT_DB(_SYSTEM_DATABASE_DATABASE);
          $pref=DB_PREFIX; 
          if ($pref!="") $pref.="_";
          $xtversion=4;
       }
	$_POST=$orgpost;

 	setlocale(LC_NUMERIC, 'en_US'); 
	echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
	
	 

/**
 *	Folgende Funktionen werden vom etope Webservice genutzt. Eine ?derung darf hier nicht erfolgen.
 */

/**
 *	Tokencheck
 */
 if ($_POST['token']!=ET8TOK) {
 	echo "<xtresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Token is invalid</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<xtresponse>";
 	exit;
 }



 
/**
 *	Ist der Token in Ordnung etope8 Befehle decodieren 
 */

 
 if ($_POST['say']=="") { 
 	echo "<xtresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Request is invalid</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<xtresponse>";
 	exit;
 }
 $say=$_POST['say'];
 $say=str_replace("[-P]","+",$say);
 $say=str_replace("[-G]","=",$say);
 $say=base64_decode($say);
 $say=str_replace("!PREF!",$pref,$say);
 if ($pref!=""){
   $say=str_replace("orders o",$pref."orders o",$say);
   $say=str_replace("orders_products op",$pref."orders_products op",$say);
 } 
 

  if (substr($say,0,8)=="SETSHIP:"){
    if ($xtversion == "4"){
		$setship = explode(":",$say);
		// Versand ID suchen
		$statusid = mysql_query("SELECT s.status_id,sd.status_name FROM xt_system_status s, xt_system_status_description sd WHERE s.status_id=sd.status_id AND sd.language_code='de' AND (sd.status_name LIKE '%Versandt%' OR sd.status_name LIKE '%Versendet%')");
		if (!mysql_error()){
			if (mysql_num_rows($statusid)>0){
				$statusid=mysql_fetch_array($statusid);
				mysql_query("INSERT INTO ".$pref."orders_status_history SET orders_id='".$setship[1]."',orders_status_id='".$statusid['status_id']."',date_added=NOW(),customer_notified=1,comments='',change_trigger='etope8'");
				if (mysql_error()){
					echo "<xtresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Markierung konnte nicht gesetzt werden\n".mysql_error()."</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<xtresponse>";
					exit;
				}
				mysql_query("UPDATE ".$pref."orders SET orders_status='".$statusid['status_id']."' WHERE orders_id='".$setship[1]."'");
			}
		}
	}
	
	if ($xtversion == "3"){
		$setship = explode(":",$say);
		// Versand ID suchen
		$statusid = mysql_query("SELECT orders_status_id FROM ".$pref."orders_status WHERE (orders_status_name LIKE '%Versandt%' OR orders_status_name LIKE '%Versendet%' OR orders_status_name LIKE '%Delivered%')");
		if (!mysql_error()){
			if (mysql_num_rows($statusid)>0){
				$statusid=mysql_fetch_array($statusid);
				mysql_query("INSERT INTO ".$pref."orders_status_history SET orders_id='".$setship[1]."',orders_status_id='".$statusid['orders_status_id']."',date_added=NOW(),customer_notified=1,comments=''");
				if (mysql_error()){
					echo "<xtresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Markierung konnte nicht gesetzt werden\n".mysql_error()."</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<xtresponse>";
					exit;
				}
				mysql_query("UPDATE ".$pref."orders SET orders_status='".$statusid['orders_status_id']."' WHERE orders_id='".$setship[1]."'");
			}
		}
	}
	exit;
 }
 
 
 $result=mysql_query($say);
 if (mysql_error()!="") { 
 	echo "<xtresponse>\n\t<Ack>Failure</Ack>\n\t<ServerTime>".date("Y-m-d H:i:s")."</ServerTime>\n\t<Errors>\n\t\t<Error>\n\t\t\t<ShortMessage>Request is invalid.\n\n".mysql_error()."</ShortMessage>\n\t\t</Error>\n\t</Errors>\n<xtresponse>";
 	exit;
 }
 

 $myecho.= "<xtresponse>\n";
 $myecho.= "\t<Ack>Success</Ack>\n";
 $myecho.= "\t<ServerTime>".date("Y-m-d H:m:s")."</ServerTime>\n";

 
 while ($row=mysql_fetch_assoc($result)){

   if ($row['date_purchased']!=""){
   
   // OS Commerce Special, hier wird Name und Vorname in einem Feld gespeichert...
   if (isset($row['customers_name']) AND !isset($row['customers_firstname']) AND !isset($row['customers_lastname'])){
   		$ca = explode(" ",$row['customers_name']);
   		if (count($ca)==1) {
   			$row['customers_firstname'] = "";
   			$row['customers_lastname'] = $row['customers_name'];
   		} else {
   			$row['customers_lastname'] = "";
   			$row['customers_firstname'] = $ca[0];
   			$cacount = 0;
   			foreach($ca AS $caa){
   				if ($cacount > 0) $row['customers_lastname'].=" ".$caa;
   				$cacount++;
   			}
   			$row['customers_lastname'] = trim($row['customers_lastname']);
   		}
   		
   		$ca = explode(" ",$row['billing_name']);
   		if (count($ca)==1) {
   			$row['billing_firstname'] = "";
   			$row['billing_lastname'] = $row['billing_name'];
   		} else {
   			$row['billing_lastname'] = "";
   			$row['billing_firstname'] = $ca[0];
   			$cacount = 0;
   			foreach($ca AS $caa){
   				if ($cacount > 0) $row['billing_lastname'].=" ".$caa;
   				$cacount++;
   			}
   			$row['billing_lastname'] = trim($row['billing_lastname']);
   		}
   		
   		$ca = explode(" ",$row['delivery_name']);
   		if (count($ca)==1) {
   			$row['delivery_firstname'] = "";
   			$row['delivery_lastname'] = $row['delivery_name'];
   		} else {
   			$row['delivery_lastname'] = "";
   			$row['delivery_firstname'] = $ca[0];
   			$cacount = 0;
   			foreach($ca AS $caa){
   				if ($cacount > 0) $row['delivery_lastname'].=" ".$caa;
   				$cacount++;
   			}
   			$row['delivery_lastname'] = trim($row['delivery_lastname']);
   		}
   }
   

	$row['shipping_cost']=0;
	
	// XT 3
	if ($xtversion==3){
		$ship=mysql_query("SELECT * FROM ".$pref."orders_total WHERE class='ot_shipping' AND orders_id=".$row['orders_id']);
		if (mysql_num_rows($ship)>0){
			$shiprow=mysql_fetch_array($ship); 
			$row['shipping_cost']=$shiprow['value'];
		} 
	}

	// XT 4
	if ($xtversion==4){
		$ship=mysql_query("SELECT * FROM ".$pref."orders_total WHERE orders_total_key='shipping' AND orders_id=".$row['orders_id']);
		if (mysql_num_rows($ship)>0){
			$shiprow=mysql_fetch_array($ship); 
			$row['shipping_cost']=$shiprow['orders_total_price'];
			$row['shipping_method']=$shiprow['orders_total_name'];
            // XT Brutto??
            if ($shiprow['orders_total_tax']!=""){
                $taxm=((100 + $shiprow['orders_total_tax']) / 100);
                if ($taxm>0) $row['shipping_cost']=round(($row['shipping_cost']*$taxm),2);
            }
		}
	}
 
	$comment=mysql_query("SELECT * FROM ".$pref."orders_status_history WHERE orders_id=".$row['orders_id']);
	$commenttext="";
	while ($commentrow=mysql_fetch_array($comment)){
		if ($commenttext=="") $commenttext.=$commentrow['comments']; else $commenttext.="\n".$commentrow['comments'];
	}
	$row['comments']=$commenttext;

	if ($xtversion==3){
		$pay=mysql_query("SELECT * FROM ".$pref."orders_total WHERE class='ot_cod_fee' AND orders_id=".$row['orders_id']);
		if (mysql_num_rows($pay)>0){
			$payrow=mysql_fetch_array($pay);
			$row['payment_cost']=$payrow['value'];
		} else { 
			$row['payment_cost']=0; 
		}
	} else { 
		$row['payment_cost']=0; 
	}
	
	// Gewicht holen...
	if ($xtversion==3 AND isset($row['products_id'])){
		$gew = mysql_query("SELECT products_weight FROM ".$pref."products WHERE products_id='".$row['products_id']."'");
		if ($gewrow=mysql_fetch_array($gew)) $row['products_weight']=$gewrow['products_weight'];
	}
	

	// DISCOUNT
	$row['discount']=0; $row['discountinfo']="";
	
	$discount=mysql_query("SELECT * FROM ".$pref."orders_total WHERE class LIKE 'ot_coupon%' AND orders_id=".$row['orders_id']);
	if (mysql_error()==""){
		if (mysql_num_rows($discount)>0){
			$discountrow=mysql_fetch_array($discount);
			$row['discount']=$discountrow['value'];
			$row['discount']=str_replace("-","",$row['discount']);
			$row['discountinfo']=$discountrow['title']." ".strip_tags($discountrow['text']);
		}  
	}
	
	// XT3-Modified Discount
	if ($xtversion==3){
		$discount=mysql_query("SELECT * FROM ".$pref."orders_total WHERE class LIKE 'ot_discount%' AND orders_id=".$row['orders_id']);
		if (mysql_error()==""){
			if (mysql_num_rows($discount)>0){
				$discountrow=mysql_fetch_array($discount);
				$row['discount']=$discountrow['value'];
				$row['discount']=str_replace("-","",$row['discount']);
				$row['discountinfo']=$discountrow['title']." ".strip_tags($discountrow['text']);
			}
		}
	}
	// ENDE DISCOUNT
	
	// XT 4 Payment Code
	if ($xtversion==4){
        $paytrans=mysql_query("SELECT * FROM ".$pref."payment x, ".$pref."payment_description xx WHERE x.payment_id=xx.payment_id AND xx.language_code='de' AND x.payment_code='".$row['payment_code']."'");
        $paytransrow=mysql_fetch_array($paytrans);
        $row['payment_code']=$paytransrow['payment_name'];
        $row['payment_class']=$paytransrow['payment_name'];
    }
 
	$attribute=""; 
	$arrr=array();
	$attrib=mysql_query("SELECT * FROM ".$pref."orders_products_attributes WHERE orders_id=".$row['orders_id']." AND orders_products_id=".$row['orders_products_id']);
	while ($atrow = mysql_fetch_array($attrib)){
		 
		$attribute.=" ".$atrow['products_options'].": ".$atrow['products_options_values'];
		if ($xtversion<>3) $row['products_price'] += $atrow['options_values_price'];
		
    	// XTC 3 Attribute Model auslesen
    	if ($xtversion==3){
    		$attrsql="SELECT a.products_id,o.products_options_name,ovv.products_options_values_name,a.attributes_model FROM products_options_values_to_products_options ovp,products_options o, products_options_values ovv, products_attributes a WHERE ".
			 "o.language_id=2 AND ".
			 "ovp.products_options_id=o.products_options_id AND ".
			 "ovv.products_options_values_id=ovp.products_options_values_id AND ".
			 "ovv.language_id=2 AND ".
			 "a.options_id=o.products_options_id AND ".
			 "a.options_values_id=ovv.products_options_values_id AND ".
			 "o.products_options_name='".$atrow['products_options']."' AND ".
			 "ovv.products_options_values_name='".$atrow['products_options_values']."' AND ".
			 "a.products_id='".$row['products_id']."'";
			  
			$attr_result=mysql_query($attrsql);
			 echo mysql_error();
			if (mysql_error()==""){
				while ($attr_row=mysql_fetch_array($attr_result)){
					$arrr[]=$attr_row['attributes_model'];
				}
			}
		} // ende
		
	}
	if (count($arrr)>0) {
		$row['products_id']=$row['products_model'];
		$row['products_model']=implode("-",$arrr);
	}
	$row['products_name'].=$attribute;
 
    $row['OrderLineItemID']="xtc-".$row['orders_id'].$row['orders_products_id'].$row['date_purchased'];
    
    // Bei OSCommerce Produktnettopreis hochrechnen.
	if ($_POST['otype']){
		if ($_POST['otype']=="5"){
			$row['products_price']=$row['products_price']*1.19;
		}
	}
    
   } // ende if date pruch

   $myecho.= "\t<dataitem>\n";
   
   // Bei Veyton gibt es die customers nicht, daher hier entsprechend modifizieren
   if ($xtversion==4){
   		$myecho.= "\t\t".'<customers_company><![CDATA['.$row['billing_company'].']]></customers_company>'."\n";
   		$myecho.= "\t\t".'<customers_firstname><![CDATA['.$row['billing_firstname'].']]></customers_firstname>'."\n";
   		$myecho.= "\t\t".'<customers_lastname><![CDATA['.$row['billing_lastname'].']]></customers_lastname>'."\n";
   		$myecho.= "\t\t".'<customers_city><![CDATA['.$row['billing_city'].']]></customers_city>'."\n";
   		$myecho.= "\t\t".'<customers_postcode><![CDATA['.$row['billing_postcode'].']]></customers_postcode>'."\n";
   		$myecho.= "\t\t".'<customers_street_address><![CDATA['.$row['billing_street_address'].']]></customers_street_address>'."\n";
   		$myecho.= "\t\t".'<customers_suburb><![CDATA['.$row['billing_suburb'].']]></customers_suburb>'."\n";
   		$myecho.= "\t\t".'<customers_state><![CDATA['.$row['billing_state'].']]></customers_state>'."\n";
   		$myecho.= "\t\t".'<customers_telephone><![CDATA['.$row['billing_phone'].']]></customers_telephone>'."\n";
   }
   // Veyton kommt Netto
   if ($xtversion==4){
   		$row['products_price']=$row['products_price']*((100+$row['products_tax'])/100);
   }
   
   foreach($row as $key => $value){
     $myecho.= "\t\t".'<'.$key.'><![CDATA['.$value.']]></'.$key.'>'."\n";
   }
   $myecho.= "\t\t<thislineend>1</thislineend>\n";
   $myecho.= "\t</dataitem>\n";
 } 
 $myecho.= "</xtresponse>\n";
 
 
 echo UTF8_ENCODE($myecho);
 
 
   // Bilder hochladen falls XT4
  if ($xtversion==4){
    include 'xtCore/main.php';
 	$media=mysql_query("SELECT * FROM ".$pref."media WHERE `file` LIKE '%ttp:%' OR `file` LIKE '%ttps:'");
 	while ($mediarow=mysql_fetch_array($media)){
 		$ziel=_SRV_WEBROOT._SRV_WEB_IMAGES."org/";
 		$xdata=file_get_contents($mediarow['file']);
 		$xsplit=explode("/",$mediarow['file']);
 		if (!$xhandle=fopen($ziel.$xsplit[count($xsplit)-1],"w+")) Continue;
 		fwrite($xhandle,$xdata);
 		fclose($xhandle);
 		
 		copy($ziel.$xsplit[count($xsplit)-1],_SRV_WEBROOT._SRV_WEB_IMAGES."product/popup/".$xsplit[count($xsplit)-1]);
 		make_thumb($ziel.$xsplit[count($xsplit)-1],_SRV_WEBROOT._SRV_WEB_IMAGES."product/thumb/".$xsplit[count($xsplit)-1],THUMB_SIZE);
 		make_thumb($ziel.$xsplit[count($xsplit)-1],_SRV_WEBROOT._SRV_WEB_IMAGES."product/info/".$xsplit[count($xsplit)-1],INFO_SIZE);
 		make_thumb($ziel.$xsplit[count($xsplit)-1],_SRV_WEBROOT._SRV_WEB_IMAGES."product/icon/".$xsplit[count($xsplit)-1],ICON_SIZE);
 		
 		mysql_query("UPDATE ".$pref."media SET `file`='".$xsplit[count($xsplit)-1]."' WHERE `id`='".$mediarow['id']."'");
 	}
  }
 

  // Funktion: Generate SEO! Diese Funktion sucht noch nicht erzeugte Produkte (XT4/VEYTON)
  if ($xtversion==4){
	  $lg=mysql_query("SELECT `code` FROM ".$pref."languages");
	  while ($lgrow=mysql_fetch_array($lg)){
		$check="SELECT * FROM ".$pref."products p, ".$pref."products_description pd WHERE p.products_id=pd.products_id AND pd.language_code='".$lgrow['code']."' AND p.products_id NOT IN (SELECT link_id FROM ".$pref."seo_url WHERE language_code='".$lgrow['code']."' AND link_type=1)"; 
		$c=mysql_query($check);
		while ($cc=mysql_fetch_array($c)){
			$seourl=$cc['language_code']."/"._getSEO($cc['products_name']);
			$seomd5=MD5($seourl);
			mysql_query("INSERT INTO ".$pref."seo_url SET url_md5='".$seomd5."',url_text='".$seourl."',link_type=1,link_id=".$cc['products_id'].",language_code='".$cc['language_code']."'");
		}
		$check="SELECT * FROM ".$pref."categories p, ".$pref."categories_description pd WHERE p.categories_id=pd.categories_id AND pd.language_code='".$lgrow['code']."' AND p.categories_id NOT IN (SELECT link_id FROM ".$pref."seo_url WHERE language_code='".$lgrow['code']."' AND link_type=2)"; 
		$c=mysql_query($check);
		while ($cc=mysql_fetch_array($c)){
			$seourl=$cc['language_code']."/"._getSEO($cc['categories_name']);
			$seomd5=MD5($seourl);
			mysql_query("INSERT INTO ".$pref."seo_url SET url_md5='".$seomd5."',url_text='".$seourl."',link_type=2,link_id=".$cc['categories_id'].",language_code='".$cc['language_code']."'");
		}
		$check="SELECT * FROM ".$pref."manufacturers WHERE manufacturers_id NOT IN (SELECT link_id FROM ".$pref."seo_url WHERE language_code='".$lgrow['code']."' AND link_type=4)"; 
		$c=mysql_query($check);
		while ($cc=mysql_fetch_array($c)){
			$seourl=$lgrow['code']."/"._getSEO($cc['manufacturers_name']);
			$seomd5=MD5($seourl);
			mysql_query("INSERT INTO ".$pref."seo_url SET url_md5='".$seomd5."',url_text='".$seourl."',link_type=4,link_id=".$cc['manufacturers_id'].",language_code='".$lgrow['code']."'");
		}
	  }
  }
  
 




// Diese Funktion erzeugt die einzelnen Bilder. Sie koennen die Bildmasse am Anfang der Datei beeinflussen
function make_thumb($src,$dest,$desired_width)
{
  unlink($dest);
  $extension = exif_imagetype($src);

  if ($extension==IMAGETYPE_JPEG) $source_image = imagecreatefromjpeg($src);
  if ($extension==IMAGETYPE_PNG) $source_image = imagecreatefrompng($src);
  if ($extension==IMAGETYPE_GIF) $source_image = imagecreatefromgif($src);
  
  $width = imagesx($source_image);
  $height = imagesy($source_image);

  $desired_height = floor($height*($desired_width/$width));
  $virtual_image = imagecreatetruecolor($desired_width,$desired_height);

  if ($extension==IMAGETYPE_PNG) imagealphablending($virtual_image, false);
  imagecopyresized($virtual_image,$source_image,0,0,0,0,$desired_width,$desired_height,$width,$height);
  
  if ($extension==IMAGETYPE_PNG) {
  	imagesavealpha($virtual_image, true);
	imagepng($virtual_image,$dest);  
   } else {
	imagejpeg($virtual_image,$dest,80);    
  }  
  return $dest.$extension;
}

/*
function _getSEO( $string ) 
{ 
   $suche = array( "@", "%", "€","ä" ,"ü" ,"ö" ,"Ä" ,"Ü" ,"Ö" ,"ß"," ","'","\"","/","\?","´","`","&",",","\(","\)" ); 
   $ersatz = array( "a", "prozent","euro","ae","ue","oe","Ae","Ue","Oe","ss","-","" ,""  ,"_",""  ,"" ,"" ,"_","-","-" ,"-" ); 
   return strtolower( str_replace( $suche, $ersatz, $string ) ); 
}
*/

function round_up ( $val, $precision ) {
    $p = pow ( 10, $precision );
    $a = $p * $val;
    $b = ceil($a);
    if((round($b - $a, 2) > 0.5)){
        $b -= 1.0;
    }
    return $b / $p;
}
 
?>